// temp.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


#include <iostream>
#include <fstream>
#include <iomanip>

using namespace std;


using namespace std;


struct Time {
	int hour;
	int minute;
	int second;
};

bool isDay(char *token)
{
	char *day[] = { "Mon\0", "Tue\0", "Wed\0", "Thu\0", "Fri\0", "Sat\0", "Sun\0" };
	bool f = false;

	for (int i =0; i<7; i++) 
		if ( !strcmp(token, day[i]) )
			f = true;

	return f;
}

bool isTraceroute(char *token)
{
	bool f = false;

	if ( !strcmp(token, "traceroute") ) 
		f = true;
	
	return f;
}

void setTime(Time *t, char *st)
{
	char *tkn, 
		 *nxt_tkn;
	char seps[]   = " :\n";

	tkn = strtok_s( st, seps, &nxt_tkn);
	t->hour=atoi(tkn);
	tkn = strtok_s( NULL, seps, &nxt_tkn);
	t->minute = atoi(tkn);
	tkn = strtok_s( NULL, seps, &nxt_tkn);
	t->second = atoi(tkn);
}


int main( int argc, // Number of strings in array argv
 char *argv[])      // Array of environment variable strings
{

	Time logTime; // Ptr to Time

	char weekday[ 80 ];
	char month[ 80 ];
	int day;
	char time[ 80 ];
	char dest[ 80 ] = { "\0" };
	
	char myDest[ 80 ] = { "\0" };
	char myDay[ 80 ] = { "\0" };
	int myTime = -1;


	// parse command line 
	if (argc == 2) 
		strcpy_s(myDest,argv[1]);
		if ( !strcmp(myDest, "?") ) {
			cout << "Trace Log Parser, Mark Spivey, March. 2010" << endl;
			cout << "description: converts traceroute log 'temp.log' to csv file 'out.csv' " << endl;
			cout << "usage:" << endl;
			cout << "parselog" << " :convert ALL entries" << endl;
			cout << "parselog ?" << " :this message" << endl;
			cout << "parselog <url>" <<  " :filter <url>" << endl;
			cout << "parselog <url> <day>" << " :filter <url> <day> ( where <day> = sat sun mon tue wed thu fri)" << endl;
			cout << "parselog <url> <day> <hour>" << " :filter <url> <day> <hour> (where <hour> = 0-23)" << endl;
			exit(-1);
		}
	else
		if (argc == 3) {
			strcpy_s(myDest,argv[1]);
			myTime = atoi(argv[2]);
		}
		else
			if (argc == 4) {
				strcpy_s(myDest,argv[1]);
				myTime = atoi(argv[2]);
				strcpy_s(myDay,argv[3]);
			}




	// open the files
	ifstream fin( "temp.log", ios::in );
	ofstream fout("outfile.csv");

	char buffer[ 1024 ];
	char *token, 
		 *next_token;
	char seps[]   = " ,\t\n";


	

	if ( !fin ) 
	{
		cerr << "File could not be opened" << endl;
		exit(1);
	}


	fin.getline(buffer, 80);
	cout << "File " << buffer << " opened" << endl; 
	while ( fin.getline(buffer, 1024) ) {
		token = strtok_s( buffer, seps, &next_token);
		if ( isDay(token) ) {
		    strcpy_s(weekday,token);
			token = strtok_s( NULL, seps, &next_token);
			strcpy_s(month, token);
			token = strtok_s( NULL, seps, &next_token);
			day = atoi(token);
			token = strtok_s( NULL, seps, &next_token);
			strcpy_s(time, token);
			setTime(&logTime, time);
		}
		else
			if ( isTraceroute(token) ) {
				for (int i=0; i < 2; i++)
					token = strtok_s( NULL, seps, &next_token);
				strcpy_s(dest,token);
			}
			else 
				if ( ((*myDest == NULL) && (myTime < 0) && (*myDay == NULL)) ||	// all records
					 ((!strcmp(dest, myDest) ) && (myTime < 0) && ( *myDay == NULL)) || // specific destination
				     ((!strcmp(dest, myDest) ) && (myTime==logTime.hour) && (*myDay == NULL)) || // and time
					 ((!strcmp(dest, myDest) ) && (myTime==logTime.hour) && (!strcmp(weekday, myDay))) ) { // and day
					while ( token != NULL ) {
						fout << token << ", ";
						token = strtok_s( NULL, seps, &next_token);
					}
					fout << endl;
				}
	}   
	fin.close();
	fout.close();
    return 0;
}


